SystemOrganization addCategory: #GTD!
SystemOrganization addCategory: 'GTD-App'!
SystemOrganization addCategory: 'GTD-Commands'!
SystemOrganization addCategory: 'GTD-Model'!
SystemOrganization addCategory: 'GTD-ModelTests'!
SystemOrganization addCategory: 'GTD-Web'!

TestCase subclass: #AccionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!AccionTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:09'!
test_01_AgregarUnaDescripcion

	| textoDescripcion accion |
	
	textoDescripcion := 'Descripcion de test'.
	accion := Accion new.
	
	self assert: accion descripcion = nil.
	
	accion descripcion: textoDescripcion.
	
	self assert: accion descripcion = textoDescripcion.
	! !

TestCase subclass: #AgenteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:34'!
newAgenteDePrueba

	^Agente example.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:33'!
test_01_AltaDeUnProyecto
	| agente  |
	
	agente := Agente new.
	self assert: agente proyectos isEmpty.
	agente addProyecto: Proyecto example.
	self assert: agente proyectos notEmpty.
! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:28'!
test_02_CualesSonLasNextActions
	| agente acciones descripcionDeLaAccionEsperada |

	agente := self newAgenteDePrueba.
	acciones := agente nextActions.
	descripcionDeLaAccionEsperada := 'Llamar al dentista para pedir un turno'.
	
	self assert: acciones anyOne descripcion = descripcionDeLaAccionEsperada.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:30'!
test_03_MarcarUnaNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar descripcionDeLaAccionSiguiente |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Llamar al dentista para pedir un turno'.
	descripcionDeLaAccionSiguiente := 'Agregar el turno a mi calendario'.
	accionAMarcar := agente nextActions anyOne.
	
	self assert: accionAMarcar descripcion = descripcionDeLaAccionAMarcar.
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne descripcion = descripcionDeLaAccionSiguiente.! !

!AgenteTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:32'!
test_04_MarcarUnaNoNextActionComoHecha

	| agente accionAMarcar descripcionDeLaAccionAMarcar descripcionDeLaAccionSiguiente proyecto |
	
	agente := self newAgenteDePrueba.
	descripcionDeLaAccionAMarcar :=  'Cargar la tarjeta SUBE'.
	descripcionDeLaAccionSiguiente := 'Llamar al dentista para pedir un turno'.
	proyecto := agente proyectos first.
	accionAMarcar := proyecto acciones last.
	
	self assert: accionAMarcar descripcion = descripcionDeLaAccionAMarcar.
	self deny: (proyecto isHecha: accionAMarcar).
	agente marcarComoHecha: accionAMarcar.
	self assert: agente nextActions anyOne descripcion = descripcionDeLaAccionSiguiente.
	self assert: (proyecto isHecha: accionAMarcar).
	! !

TestCase subclass: #ProyectoTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-ModelTests'!

!ProyectoTest methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:24'!
test_01_AgregarUnaAccionAUnProyecto
	
	| proyecto accionPorAgregar |
	proyecto := Proyecto new.
	accionPorAgregar := Accion descripcion: 'Accion de test'.
	
	self assert: proyecto acciones isEmpty.
	
	proyecto addAccion: accionPorAgregar.
	
	self assert: proyecto acciones notEmpty.
	! !

Object subclass: #Accion
	instanceVariableNames: 'descripcion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Accion commentStamp: '<historical>' prior: 0!
Please comment me using the following template inspired by Class Responsibility Collaborator (CRC) design:

For the Class part:  State the name of the class with one line description: For example, I'm xxx the root of the hierarchy of visitor objects.

For the Responsibility part: Three sentences about my main responsibility, what I'm doing, what services do I offer.

For the Collaborators Part: State my main collaborators and one line about how I interact with them. 

Public API and Key Messages

- message one   
- message two 
- what is the way to create instances is a plus.

   One simple example is simply gorgeous.
 
Internal Representation and Key Implementation Points.

    Instance Variables
	descripcion:		<Object>


    Implementation Points!

!Accion class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:26'!
descripcion: aString

	^ self new descripcion: aString.! !

!Accion methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/28/2015 10:01'!
descripcion
	^ descripcion! !

!Accion methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/28/2015 10:11'!
descripcion: aTextoDescriptivo
	descripcion := aTextoDescriptivo! !

Object subclass: #Agente
	instanceVariableNames: 'proyectos realizacionesDeProyectos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Agente commentStamp: 'SergioFedi 4/24/2015 18:49' prior: 0!
Soy una entidad que tiene agencia. Es decir, que quiere lograr algo en la realidad. Por lo tanto voya tener proyectos que voy a querer llevar a cabo.!

!Agente class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:31'!
example
	| agente unProyecto  |
	
	agente := Agente new.
	unProyecto := Proyecto example.
	agente addProyecto: unProyecto.
	^ agente.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/23/2015 11:00'!
addProyecto: aProyecto 
	self proyectos add: aProyecto.! !

!Agente methodsFor: 'initialization' stamp: 'FedericoFigueredo 4/23/2015 11:07'!
initialize

	self proyectos: OrderedCollection new.! !

!Agente methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:50'!
marcarComoHecha: anAccion 
	| proyecto | 
	
	proyecto := self proyectos detect: [ :each | each includesAccion: anAccion ].
	
	proyecto marcarComoHecha: anAccion.! !

!Agente methodsFor: 'public' stamp: 'FedericoFigueredo 4/27/2015 09:49'!
nextActions
	^ self proyectos collect: [ :aProyecto | aProyecto nextAction ].
	! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos
	^ proyectos! !

!Agente methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/23/2015 11:02'!
proyectos: anObject
	proyectos := anObject! !

Object subclass: #AgregarProyectoCmd
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Commands'!

!AgregarProyectoCmd commentStamp: 'SergioFedi 4/25/2015 10:07' prior: 0!
Modelo el agregado de un Proyecto al sistema desde fuera del sistema.
!

Object subclass: #GTDApplication
	instanceVariableNames: 'agente'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-App'!

!GTDApplication class methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/28/2015 09:52'!
example

	^self new agente: Agente example.! !

!GTDApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/28/2015 09:51'!
agente
	^ agente! !

!GTDApplication methodsFor: 'accessing' stamp: 'SergioFedi 4/28/2015 09:51'!
agente: anObject
	agente := anObject! !

Object subclass: #GTDWebHandler
	instanceVariableNames: 'app'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Web'!

!GTDWebHandler methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/28/2015 10:29'!
defaultResponseEntity
	| htmlStream |
	htmlStream := WriteStream on: String new.
	app agente proyectos do: [:proyecto |.
		htmlStream nextPutAll: ('Proyecto ', proyecto nombre, '<br>').
		proyecto acciones do: [ :accion |
			htmlStream nextPutAll: (accion descripcion, '<br>').
		].
	].
	^ '<h1>', htmlStream contents, '</h1>'.! !

!GTDWebHandler methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/28/2015 09:27'!
handleRequest: aRequest
	| response |
	response := ZnResponse new
		statusLine: ZnStatusLine ok;
		headers: ZnHeaders defaultResponseHeaders;
		yourself.
	response entity: (ZnStringEntity html: self defaultResponseEntity).
	^ response! !

!GTDWebHandler methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/28/2015 09:50'!
initialize

	app := GTDApplication example.
! !

Object subclass: #GTDWebServer
	instanceVariableNames: 'staticHandler dynamicHandler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Web'!

!GTDWebServer commentStamp: 'SergioFedi 4/27/2015 21:28' prior: 0!
Esta clase se encarga de manejar los pedidos HTTP que quieren interactuar con una aplicacion GTD (GTDApp)!

!GTDWebServer methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 22:47'!
handleRequest: aRequest

	(aRequest uri segments notNil and: [aRequest uri segments first = 'static']) ifTrue: [
		^staticHandler handleRequest: aRequest].
	^dynamicHandler handleRequest: aRequest.! !

!GTDWebServer methodsFor: 'as yet unclassified' stamp: 'SergioFedi 4/27/2015 23:03'!
initialize
	super initialize.
	staticHandler := (ZnStaticFileServerDelegate new
		directory: (ZnFileSystemUtils directory: 'D:\Trabajo\RPD\Desarrollo\www');
		prefixFromString: 'static';
		yourself).
	dynamicHandler := GTDWebHandler new.! !

Object subclass: #Proyecto
	instanceVariableNames: 'nombre condicionDeExito acciones accionesHechas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GTD-Model'!

!Proyecto commentStamp: 'FedericoFigueredo 4/23/2015 14:28' prior: 0!
Llamamos Proyecto a un estado de la realidad deseado para el cual se requieren la realización de más de una acción.!

!Proyecto class methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 10:23'!
example
	| unProyecto | 
	
	unProyecto := self new.
	
	unProyecto 
		addAccion: (Accion descripcion: 'Llamar al dentista para pedir un turno');
		addAccion: (Accion descripcion: 'Agregar el turno a mi calendario');
		addAccion: (Accion descripcion: 'Ir a la consulta');
		addAccion: (Accion descripcion: 'Cargar la tarjeta SUBE').
	unProyecto
		nombre: 'Chequeo Dental';
		condicionDeExito: 'Saber el estado actual de mis dientes'.
	
	^ unProyecto.! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones
	^ acciones! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
acciones: anObject
	acciones := anObject! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/27/2015 10:20'!
accionesHechas
	^ accionesHechas! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/28/2015 09:54'!
addAccion: anAccion 
	self acciones add: anAccion.! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito
	^ condicionDeExito! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
condicionDeExito: anObject
	condicionDeExito := anObject! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:40'!
includesAccion: anAccion 
	^ self acciones includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:24'!
initialize
	acciones := OrderedCollection new.
	accionesHechas := OrderedCollection new.
	! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:24'!
isHecha: anAccion 
	^ self accionesHechas includes: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:51'!
marcarComoHecha: anAccion 
	self accionesHechas add: anAccion.! !

!Proyecto methodsFor: 'as yet unclassified' stamp: 'FedericoFigueredo 4/27/2015 10:37'!
nextAction
	^ self acciones detect: [ :accion | (self isHecha: accion) not ].! !

!Proyecto methodsFor: 'public' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre
	^ nombre! !

!Proyecto methodsFor: 'accessing' stamp: 'FedericoFigueredo 4/22/2015 13:12'!
nombre: anObject
	nombre := anObject! !
